$.ajaxSetup({
    timeout: 10000
});

function getApiPath() {
	return 'http://app-template.localhost/api.php/';
}


/* START HELPER FUNCTIONS */
function br2nl(str) {
    return str.replace(/<br\s*\/?>/mg, "\n");
}

function nl2br(str) {
    return str.replace(/\n/g, "<br/>");
}

function showError() {
    var content = '<div id="error">No internet connection.<br/>Please try again later.</div>';
    $('#content').html(content);
    $('#error').fadeIn(2000);
}

function getDate() {
    var today = new Date();
	var dd = today.getDate();
	var mm = today.getMonth()+1; //January is 0!
	var yyyy = today.getFullYear();

	if(dd<10) {
		dd='0'+dd
	} 

	if(mm<10) {
		mm='0'+mm
	} 

	today = dd+'.'+mm+'.'+yyyy;
	return today;
}

function formatDate(date) {
    var datum = new Date(date);
    var month = datum.getMonth() + 1;
    if (month < 10) {
        month = '0' + month;
    }
	
    return datum.getDate() + '.' + month + '.' + datum.getFullYear();
}

function getDateRangeOfWeek(weekNo) {
		var d1 = new Date();
		numOfdaysPastSinceLastMonday = eval(d1.getDay()- 1);
		d1.setDate(d1.getDate() - numOfdaysPastSinceLastMonday);
		var weekNoToday = d1.getWeek();
		var weeksInTheFuture = eval( weekNo - weekNoToday );
		d1.setDate(d1.getDate() + eval( 7 * weeksInTheFuture ));
		var rangeIsFrom =  eval(d1.getMonth()+1)   +"/"  +  d1.getDate()  + "/"  +   d1.getFullYear();
		d1.setDate(d1.getDate() + 6);		
		var rangeIsTo = eval(d1.getMonth()+1)   +"/"  +  d1.getDate()  + "/"  +   d1.getFullYear();
		var from = formatDate(rangeIsFrom);
		var to = formatDate(rangeIsTo);
		return from.substring(0, from.length - 4) + " - " + to.substring(0, to.length - 4);
}

Date.prototype.getWeek = function() {
	var onejan = new Date(this.getFullYear(), 0, 1);
	return Math.ceil((((this - onejan) / 86400000) + onejan.getDay() + 1) / 7);
}

function getCalWeek(plus) {
    var weekNumber = (new Date()).getWeek() + plus;
	return weekNumber;
}

function numberWithCommas(x) {
	if(x != null)
		return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
	else
		return x;
}

function getMonthName(month) {
    switch(month) {
        case 1:
            return 'Jänner';
        case 2:
            return 'Februar';
        case 3:
            return 'März';
        case 4:
            return 'April';
        case 5:
            return 'Mai';
        case 6:
            return 'Juni';
        case 7:
            return 'Juli';
        case 8:
            return 'August';
        case 9:
            return 'September';
        case 10:
            return 'Oktober';
        case 11:
            return 'November';
        case 12:
            return 'Dezember';
        default:
            return undefined;
    }
}

function getDayName(date) {
	var d = new Date(date);
	var n = d.getDay();
    switch(n) {
        case 0:
            return 'So';
        case 1:
            return 'Mo';
        case 2:
            return 'Di';
        case 3:
            return 'Mi';
        case 4:
            return 'Do';
        case 5:
            return 'Fr';
        case 6:
			return 'Sa';
        default:
            return undefined;
    }
}
/* END HELPER FUNCTIONS */

function checkPreAuth() {
    var form = $('#loginForm');
    if (window.localStorage['username'] != undefined && window.localStorage['password'] != undefined) {
        $('#username', form).val(window.localStorage['username']);
        $('#password', form).val(window.localStorage['password']);
        handleLogin();
    }
}

function handleLogin() {
    $('#loginError').html('');
    var form = $('#loginForm');    

    $('#submit', form).attr('disabled', 'disabled');
    var u = $('#username', form).val();
    var p = $('#password', form).val();

    if(u != '' && p!= '') {
        $.ajax({
            dataType: 'jsonp',
            jsonp: false,
            jsonpCallback: 'login',
            data: 'username='+u+'&password='+p,
            url: getApiPath()+'login',
            success: function(data) {
                if(data != false && data > 0) {
                    window.localStorage['username'] = u;
                    window.localStorage['password'] = p;
                    window.localStorage['id'] = data;
                    window.location = 'usermenu.html';
                }
				else {
                    $('#loginError').html('Falscher Username und/oder falsches Passwort.');
                }
                $('#submit').removeAttr('disabled');
            }
        });
    }
	else {
        $('#loginError').html('Bitte geben Sie einen Usernamen und ein Passwort an.');
        $('#submit').removeAttr('disabled');
    }
    return false;
}

function nodeListToArray(obj) {
  var array = [];
  // iterate backwards ensuring that length is an UInt32
  for (var i = 0; i < obj.length; i++) { 
    array[i] = obj[i].value;
  }
  return array;
}
